from app import app
from pyrogram import filters
from pyrogram.types import Message
from pyrogram.client import Client
from modules.utils import should_quote, logWrite, locale
from modules.database import col_tmp, col_spoilers
from modules import custom_filters

@app.on_message((custom_filters.enabled_applications | custom_filters.enabled_sponsorships) & ~filters.scheduled & filters.command("cancel", prefixes=["/"]))
async def command_cancel(app: Client, msg: Message):
    col_tmp.delete_many( {"user": msg.from_user.id} )
    col_spoilers.delete_many( {"user": msg.from_user.id, "completed": False} )
    await msg.reply_text(locale("cancel", "message", locale=msg.from_user), quote=should_quote(msg))
    logWrite(f"Cancelling all ongoing tmp operations for {msg.from_user.id}")