from app import app, isAnAdmin
from pyrogram.types import ChatPermissions, InlineKeyboardMarkup, InlineKeyboardButton, ChatMemberUpdated
from pyrogram.client import Client
from modules.utils import configGet, locale
from modules.logging import logWrite
from classes.holo_user import HoloUser
from modules import custom_filters

# Filter users on join =========================================================================================================
@app.on_chat_member_updated(custom_filters.enabled_invites_check, group=configGet("users", "groups"))
#@app.on_message(filters.new_chat_members, group=configGet("users", "groups"))
async def filter_join(app: Client, member: ChatMemberUpdated):

    if member.invite_link != None:

        holo_user = HoloUser(member.from_user)

        if (holo_user.link is not None) and (holo_user.link == member.invite_link.invite_link):
            logWrite(f"User {holo_user.id} joined destination group with correct link {holo_user.link}")
            return
        
        if await isAnAdmin(member.invite_link.creator.id):
            logWrite(f"User {holo_user.id} joined destination group with link {holo_user.link} of an admin {member.invite_link.creator.id}")
            return

        logWrite(f"User {holo_user.id} joined destination group with stolen/unapproved link {holo_user.link}")

        await app.send_message(configGet("admin", "groups"), locale("joined_false_link", "message").format(member.from_user.first_name, member.from_user.id), reply_markup=InlineKeyboardMarkup(
            [
                [
                    InlineKeyboardButton(text=str(locale("sus_allow", "button")), callback_data=f"sus_allow_{member.from_user.id}")
                ],
                [
                    InlineKeyboardButton(text=str(locale("sus_reject", "button")), callback_data=f"sus_reject_{member.from_user.id}")
                ]
            ]
        ))
        await app.restrict_chat_member(member.chat.id, member.from_user.id, permissions=ChatPermissions(
                can_send_messages=False,
                can_send_media_messages=False,
                can_send_other_messages=False,
                can_send_polls=False
            )
        )
# ==============================================================================================================================